"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigReader_1 = require("./ConfigReader");
var BuilderDiscoverer = (function () {
    function BuilderDiscoverer(spin, plugins, argv) {
        this.configReader = new ConfigReader_1.default(spin, plugins);
        this.argv = argv;
    }
    BuilderDiscoverer.prototype.discover = function () {
        if (this.argv.c) {
            return this.configReader.readConfig(this.argv.c);
        }
        else {
            var candidates = ['package.json', '.spinrc.json', '.spinrc', '.spinrc.js'];
            for (var _i = 0, candidates_1 = candidates; _i < candidates_1.length; _i++) {
                var fileName = candidates_1[_i];
                var builders = this.configReader.readConfig(fileName);
                if (builders) {
                    return builders;
                }
            }
        }
        return undefined;
    };
    return BuilderDiscoverer;
}());
exports.default = BuilderDiscoverer;
//# sourceMappingURL=BuilderDiscoverer.js.map