"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var merge = require("webpack-merge");
var requireModule_1 = require("./requireModule");
var Spin = (function () {
    function Spin(cwd, cmd) {
        this.cmd = cmd;
        this.cwd = cwd;
        this.dev = this.cmd === 'watch' || this.cmd === 'test';
        this.test = this.cmd === 'test';
        this.watch = this.cmd === 'watch';
        this.require = (function () {
            var require = function (name, relativeTo) { return requireModule_1.default(name, relativeTo || cwd); };
            require.resolve = function (name, relativeTo) { return requireModule_1.default.resolve(name, relativeTo || cwd); };
            require.probe = function (name, relativeTo) { return requireModule_1.default.probe(name, relativeTo || cwd); };
            return require;
        })();
    }
    Spin.prototype.merge = function (config, overrides) {
        return merge.smart(config, overrides);
    };
    Spin.prototype.mergeWithStrategy = function (strategy, config, overrides) {
        return merge.smartStrategy(strategy)(config, overrides);
    };
    return Spin;
}());
exports.default = Spin;
//# sourceMappingURL=Spin.js.map